*-----------------------------------------------------------------------
*     Copyright (C) 2000-2004 GFD Dennou Club. All rights reserved.
*-----------------------------------------------------------------------
      SUBROUTINE SWCQNP(NCP)

      CHARACTER CP*(*), CVAL*(*)
      PARAMETER (NPARA = 15)
      LOGICAL   LCHREQ, LFIRST
      CHARACTER CPARAS(NPARA)*8
      CHARACTER CPARAL(NPARA)*40
      CHARACTER CX(NPARA)*80, CMSG*80

      EXTERNAL  LCHREQ, LENC

      SAVE

      DATA      CPARAS( 1)/'WSNAME01'/, CX( 1)/'GTK     '/
      DATA      CPARAS( 2)/'WSNAME02'/, CX( 2)/'PS      '/
      DATA      CPARAS( 3)/'WSNAME03'/, CX( 3)/'PDF     '/
      DATA      CPARAS( 4)/'WSNAME04'/, CX( 4)/'png     '/
      DATA      CPARAS( 5)/'WSNAME05'/, CX( 5)/'SVG     '/
      DATA      CPARAS( 6)/'FNAME   '/, CX( 6)/'dcl     '/
      DATA      CPARAS( 7)/'TITLE   '/, CX( 7)/'*       '/
      DATA      CPARAS( 8)/'CLRMAP  '/, CX( 8)/'colormap'/
      DATA      CPARAS( 9)/'BITMAP  '/, CX( 9)/'bitmap  '/
      DATA      CPARAS(10)/'CL2TN   '/, CX(10)/'cl2tnmap'/
      DATA      CPARAS(11)/'FONT1   '/, CX(11)/'font1u  '/
      DATA      CPARAS(12)/'FONT2   '/, CX(12)/'font2u  '/
      DATA      CPARAS(13)/'LPR     '/, CX(13)/'lpr     '/
      DATA      CPARAS(14)/'CIMGFMT '/, CX(14)/'png     '/
      DATA      CPARAS(15)/'CMAPLIST'/, CX(15)/'cmaplist'/

      DATA      CPARAL( 1)/'DEVICE_NAME01'/
      DATA      CPARAL( 2)/'DEVICE_NAME02'/
      DATA      CPARAL( 3)/'DEVICE_NAME03'/
      DATA      CPARAL( 4)/'DEVICE_NAME04'/
      DATA      CPARAL( 4)/'DEVICE_NAME05'/
      DATA      CPARAL( 6)/'FRAME_NAME'/
      DATA      CPARAL( 7)/'TITLE'/
      DATA      CPARAL( 8)/'COLORMAP'/
      DATA      CPARAL( 9)/'BITMAP'/
      DATA      CPARAL(10)/'COLOR_TO_TONE_MAP'/
      DATA      CPARAL(11)/'FONT1'/
      DATA      CPARAL(12)/'FONT2'/
      DATA      CPARAL(13)/'LPR'/
      DATA      CPARAL(14)/'IMAGE_FORMAT'/
      DATA      CPARAL(15)/'COLORMAP_LIST'/

      DATA      LFIRST / .TRUE. /


      NCP = NPARA

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQID(CP, IDX)

      DO 10 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IDX = N
          RETURN
        END IF
   10 CONTINUE
      CMSG = 'PARAMETER '''//CP(1:LENC(CP))//''' IS NOT DEFINED.'
      CALL MSGDMP('E', 'SWCQID', CMSG)

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQCP(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAS(IDX)
      ELSE
        CALL MSGDMP('E', 'SWCQCP', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQCL(IDX, CP)

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CP = CPARAL(IDX)
      ELSE
        CALL MSGDMP('E', 'SWCQCL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQVL(IDX, CVAL)

      IF (LFIRST) THEN
        CALL RTCGET('SW', CPARAS, CX, NPARA)
        CALL RLCGET(CPARAL, CX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CVAL = CX(IDX)
      ELSE
        CALL MSGDMP('E', 'SWCQVL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCSVL(IDX, CVAL)

      IF (LFIRST) THEN
        CALL RTCGET('SW', CPARAS, CX, NPARA)
        CALL RLCGET(CPARAL, CX, NPARA)
        LFIRST = .FALSE.
      END IF

      IF (1.LE.IDX .AND. IDX.LE.NPARA) THEN
        CX(IDX) = CVAL
      ELSE
        CALL MSGDMP('E', 'SWCSVL', 'IDX IS OUT OF RANGE.')
      END IF

      RETURN
*-----------------------------------------------------------------------
      ENTRY SWCQIN(CP, IN)

      DO 20 N = 1, NPARA
        IF (LCHREQ(CP, CPARAS(N)) .OR. LCHREQ(CP, CPARAL(N))) THEN
          IN = N
          RETURN
        END IF
   20 CONTINUE

      IN = 0

      RETURN
      END
